/*---------------------------------------------------------------------------*\

    Copyright (C) 2000 AVM GmbH. All rights reserved.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY, without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE, and WITHOUT
    ANY LIABILITY FOR ANY DAMAGES arising out of or in connection
    with the use or performance of this software. See the
    GNU General Public License for further details.

\*---------------------------------------------------------------------------*/

#ifndef _CSUNIONS_H_
#define _CSUNIONS_H_

#include "aTypes.h"
#include "capi2def.h"

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/

typedef struct _cu_B1Configuration {    // For Protocol:
    tUShort MaximumBitRate;                 // 2, 3, 4, 7, 8, 9
    tUShort BitsPerCharacter;               // 2, 7, 8
    tUShort Parity;                         // 2, 7, 8
    tUShort StopBits;                       // 2, 7, 8
    tUShort Options;                        // 7, 8, 9
    tUShort SpeedNegotiation;               // 7, 8, 9
    tUShort TransmitLevelInDB;              // 4
} cu_B1Configuration;

typedef struct _cu_B3Configuration {    // For Protocol:
    tUShort LIC;                            // 1, 2, 3
    tUShort HIC;                            // 1, 2, 3
    tUShort LTC;                            // 1, 2, 3
    tUShort HTC;                            // 1, 2, 3
    tUShort LOC;                            // 1, 2, 3
    tUShort HOC;                            // 1, 2, 3
    tUShort ModuloMode;                     // 1, 2, 3
    tUShort WindowSize;                     // 1, 2, 3
    tUShort Resolution;                     // 4
    tUShort Format;                         // 4, 5
    tUChar *StationID;                      // 4, 5
    tUChar *HeadLine;                       // 4, 5
    tUShort Options;                        // 5
} cu_B3Configuration;

typedef struct _cu_NCPI {               // For B3Protocol:
    tUByte  Flags;                          // 2, 3
    tUByte  Group;                          // 2, 3
    tUByte  Channel;                        // 2, 3
  //tUByte *Contents;                  // 2, 3  TODO: not implemented yet
    tUShort Options;                        // 3, 5
    tUShort Rate;                           // 4, 5, 7
    tUShort Resolution;                     // 5
    tUShort Format;                         // 4, 5
    tUShort Pages;                          // 4, 5
    tUChar *ReceiveID;                      // 4, 5
    tUShort Protocol;                       // 7
} cu_NCPI;

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/

#endif
