/*---------------------------------------------------------------------------*\
 * Copyright (C) 2000 AVM GmbH. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY, without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE, and WITHOUT 
 * ANY LIABILITY FOR ANY DAMAGES arising out of or in connection 
 * with the use or performance of this software. See the
 * GNU General Public License for further details.
\*---------------------------------------------------------------------------*/

#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include "sff2huf.h"
#include "huf2ftif.h"

void DebugOutput (char *string) {
    printf (string);
}

void main (void) {
    CSFilter_Sff2Huf s2h;
    CSFilter_Huf2fTif h2t;

    int sffd = open ("sample.sff", O_RDONLY);
    if (sffd < 0) {
        return 0;
    }
    if (s2h.Open (0) == vFalse) {
        close (sffd);
        return 0;
    }
    int fd = open ("output.tif", O_CREAT | O_WRONLY);
    if ((fd < 0) || (h2t.Open (fd, (tUChar *)"output.tif") == vFalse)) {
        s2h.Close ();
        close (sffd);        
        return 0;
    }
    h2t.PutPageHeader (98, 204, 1146, 1728, 0, (tUChar *)"test1", (tUChar *)"test2", (tUChar *)"test3", (tUChar *)"test4", (tUChar *)"test5");
    tUChar test[100];
    CSFilter_Sff2Huf::ctInfo info;
    tUInt len;
    tUInt exit = 0;
    printf ("Loop:\n");
    while (!exit) {
        len = read (sffd, test, 100);
        for (tUInt i = 0; i < len; i++) {
            s2h.PutChar (test[i]);
        }
        len = s2h.GetToPageEnd (test, 100, &info);
        printf ("u=%x, ", len);
        if (len) {
            h2t.Put (test, len);
        }
        switch (info) {
        case CSFilter_Sff2Huf::i_Normal:
            break;
        case CSFilter_Sff2Huf::i_NewPage:
            printf ("\nPageEnd!\n");
            h2t.PutPageEnd (vFalse, 0);
            h2t.PutPageHeader (98, 204, 1146, 1728, 0, (tUChar *)"test1", (tUChar *)"test2", (tUChar *)"test3", (tUChar *)"test4", (tUChar *)"test5");
            break;
        case CSFilter_Sff2Huf::i_LastPage:
            printf ("\nLastPageEnd!\n");
            h2t.PutPageEnd (vTrue, 0);
            exit = 1;
            break;
        default:
            printf ("\n\nError(%x)!!!\n\n", info);
            h2t.PutPageEnd (vTrue, 0);
            exit = 1;
            break;
        }
    }

    s2h.Close();
    h2t.Close();
    close (sffd);
    return 0;
}

