/*---------------------------------------------------------------------------*\
 * Modul : FilePars.cpp vom Freitag, 13. Oktober 2000 14:26 von MRolf
 *
 * $Id$
 *
 * $Log$
\*---------------------------------------------------------------------------*/

#include "FilePars.h"
#include "osImport.h"

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/

#define CONFIGPARSER_MaxLength              200

/*===========================================================================*\
\*===========================================================================*/

CConfigFileParser::ctInfo CConfigFileParser::ParseFile (tUChar *FileName) {
    dhead ("CConfigFileParser::ParseFile", DEBUG_ConfigParser);
    dassert (FileName != 0);
    ctInfo fret;
    FILE *hFile = fopen ((char *)FileName, "r");
    if (!hFile) {
        return i_Err_OpenFailed;
    }
    fret = ParseFile (hFile);
    fclose (hFile);
    return fret;
}

/*===========================================================================*\
\*===========================================================================*/

CConfigFileParser::ctInfo CConfigFileParser::ParseFile (FILE *FileHandle) {
    dhead ("CConfigFileParser::ParseFile", DEBUG_ConfigParser);
    dassert (FileHandle != 0);
    char           szPartLine[CONFIGPARSER_MaxLength + 1];
    CDynamicString curLine;
    tUInt          curLineNr = 0;
    ctInfo         fret;

    if (!GetMainSection()) {
        return i_Err_MemoryFull;
    }
    // TODO?: set file position to begin of file?
    // fseek (FileHandle, 0, SEEK_SET);
    while (!feof (FileHandle)) {
        if (fgets (szPartLine, CONFIGPARSER_MaxLength, FileHandle)) {
            if (curLine.Append ((tUChar *)szPartLine) == vFalse) {
                return i_Err_MemoryFull;
            }
            if (curLine.GetLen()) {
                switch (curLine.GetLastChar()) {
                case '\r':
                case '\n':
                    do {
                        curLine.SetLen (-1);
                    } while (  (curLine.GetLastChar() == '\r')
                            || (curLine.GetLastChar() == '\n'));
                    dprint ("ParseLine=(%s)\n", curLine.GetPointer());
                    fret = ParseLine (&curLine);
                    switch (fret) {
                    case i_Okay:
                    case i_Pending:
                        break;
                    case i_Err_MemoryFull:
                        return fret;
                    default:
                        LineCodingError (++curLineNr, &curLine);
                        break;
                    }
                    break;
                }
            }
        }
        curLine.RemoveAll();
    }
    return (ParseLine (0) == i_Err_MemoryFull) ? i_Err_MemoryFull : i_Okay;
}


/*===========================================================================*\
\*===========================================================================*/
