/*---------------------------------------------------------------------------*\

    Copyright (C) 2000 AVM GmbH. All rights reserved.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY, without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE, and WITHOUT
    ANY LIABILITY FOR ANY DAMAGES arising out of or in connection
    with the use or performance of this software. See the
    GNU General Public License for further details.

\*---------------------------------------------------------------------------*/

#include "SortList.h"
#include "osImport.h"

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/

static tResult FindElementFromCompareData (CSortPListElement *pElement, void *RefData) {
    dhead ("FindElementFromCompareData", DEBUG_CPointerList);
    switch (pElement->Compare (RefData)) {
    case vLower:
        return vNo;
    case vEqual:
        return vYes;
    default:
        dassert (0);
        // no break!
    case vHigher:
        break;
    }
    return vCancel;
}

/*===========================================================================*\
\*===========================================================================*/

void CSortPointerList::Add (CSortPListElement *pElement) {
    dhead ("CSortPointerList::Add", DEBUG_CPointerList);
    void *RefCompData = pElement->GetRefCompData();
    for (CSortPListElement *pLauf = GetHighest(); (pLauf); pLauf = pLauf->GetLower()) {
        if (pLauf->Compare (RefCompData) == vHigher) {
            pLauf->AddBefore (pElement);
            return;
        }
    }
    AddLast (pElement);
}

/*===========================================================================*\
\*===========================================================================*/

CSortPListElement *CSortPointerList::Find (void *CompData) {
    dhead ("CSortPointerList::Find", DEBUG_CPointerList);
    return Find ((ctFindFunc)FindElementFromCompareData, CompData);
}

/*===========================================================================*\
\*===========================================================================*/
