/*---------------------------------------------------------------------------*\

    Copyright (C) 2000 AVM GmbH. All rights reserved.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY, without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE, and WITHOUT
    ANY LIABILITY FOR ANY DAMAGES arising out of or in connection
    with the use or performance of this software. See the
    GNU General Public License for further details.

\*---------------------------------------------------------------------------*/

#ifndef _ATYPES_H_
#define _ATYPES_H_

//#include "platform.h"

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/

#if defined __STDC_VERSION__ && __STDC_VERSION__ >= 199901L
    #include <stdint.h>
#else

typedef signed char        int8_t;
typedef short int          int16_t;
typedef int                int32_t;

typedef unsigned char      uint8_t;
typedef unsigned short int uint16_t;
typedef unsigned int       uint32_t;

#ifdef __linux__
    #if __WORDSIZE == 64
        typedef long int int64_t;
        typedef unsigned long int uint64_t;
    #else
        typedef long long int int64_t;
        typedef unsigned long long int uint64_t;
    #endif
#else
    typedef __int64 int64_t;
    typedef unsigned __int64 uint64_t;
#endif // __linux__

#endif // __STDC_VERSION__

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/

#ifdef __cplusplus

typedef bool    tBool;
#define vFalse  false
#define vTrue   true

#else

enum tBool {
    vFalse = 0,
    vTrue = 1
};

#endif

enum tCompare {
    vLower  = -1,
    vEqual  = 0,
    vHigher = 1
};

enum tResult {
    vError  = -2,
    vCancel = -1,
    vNo     = 0,
    vYes    = 1
};

typedef uint8_t     tUChar;
typedef int8_t      tSChar;

typedef uint16_t    tUWiChar;
typedef int16_t     tSWiChar;

typedef uint8_t     tUByte;
typedef int8_t      tSByte;

typedef uint16_t    tUShort;
typedef int16_t     tSShort;

typedef uint32_t    tUInt;
typedef int32_t     tSInt;

typedef uint64_t    tULong;
typedef int64_t     tSLong;

// Integer, with size of a pointer
#ifdef C_PLATFORM_64
typedef tULong      tPLong;
#else
typedef tUInt       tPLong;
#endif

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/

#define MAXVAL_tUChar       ((tUChar) -1)
#define MAXVAL_tSChar       ((tSChar) ((MAXVAL_tUChar - 1) / 2))
#define MINVAL_tSChar       ((tSChar) - MAXVAL_tSChar - 1)

#define MAXVAL_tUWiChar     ((tUWiChar) -1)
#define MAXVAL_tSWiChar     ((tSWiChar) ((MAXVAL_tUWiChar - 1) / 2))
#define MINVAL_tSWiChar     ((tSWiChar) - MAXVAL_tSWiChar - 1)

#define MAXVAL_tUByte       ((tUByte) -1)
#define MAXVAL_tSByte       ((tSByte) ((MAXVAL_tUByte - 1) / 2))
#define MINVAL_tSByte       ((tSByte) - MAXVAL_tSByte - 1)

#define MAXVAL_tUShort      ((tUShort) -1)
#define MAXVAL_tSShort      ((tSShort) ((MAXVAL_tUShort - 1) / 2))
#define MINVAL_tSShort      ((tSShort) - MAXVAL_tSShort - 1)

#define MAXVAL_tUInt        ((tUInt) -1)
#define MAXVAL_tSInt        ((tSInt) ((MAXVAL_tUInt - 1) / 2))
#define MINVAL_tSInt        ((tSInt) - MAXVAL_tSInt - 1)

#define MAXVAL_tULong       ((tULong) -1)
#define MAXVAL_tSLong       ((tSLong) ((MAXVAL_tULong - 1) / 2))
#define MINVAL_tSLong       ((tSLong) - MAXVAL_tSLong - 1)

#endif
