/*---------------------------------------------------------------------------*\

    Copyright (C) 2000 AVM GmbH. All rights reserved.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY, without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE, and WITHOUT
    ANY LIABILITY FOR ANY DAMAGES arising out of or in connection
    with the use or performance of this software. See the
    GNU General Public License for further details.

\*---------------------------------------------------------------------------*/

#ifndef __cbttimer_h__
#define __cbttimer_h__

#include "StdTimer.h"

typedef void (* tCCallBackTimerFunc) (void *, void *);

class CCallBackTimer : public CStandardTimer {

public:
    CCallBackTimer (tCCallBackTimerFunc cbfunc = 0);

    void SetCallBack (tCCallBackTimerFunc cbfunc);

private:
    void TimerEvent (void * handle1, void * handle2);

    tCCallBackTimerFunc func;
};

/*---------------------------------------------------------------------------*\
 * Inliners
\*---------------------------------------------------------------------------*/

inline CCallBackTimer::CCallBackTimer (tCCallBackTimerFunc cbfunc) {

	SetCallBack (cbfunc);
} // CCallBackTimer::CCallBackTimer

inline void CCallBackTimer::TimerEvent (void * handle1, void * handle2) {
	tCCallBackTimerFunc cbfunc = func;

	if (cbfunc) {
		cbfunc (handle1, handle2);
	}
} // CCallBackTimer::TimerEvent

inline void CCallBackTimer::SetCallBack (tCCallBackTimerFunc cbfunc) {

	func = cbfunc;
} // CCallBackTimer::SetCallBack

#endif

